UNIT ClassicCalcul8;

INTERFACE

uses
  ClassicDecla;

function conforme8(nw: ar_w): boolean;
	{ entre: nw                 				}
	{ sortie: conforme8 = true                              }
        {         sauf si nw = 00000000000000000000000000000000 }
        {                      7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF }
        {                      80000000000000000000000000000000 }
        {                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF }
function parite(var na: ar_w): boolean; pascal; assembler;
         { sortie = true lorsque le nombre de bits 1 est pair dans na }
procedure DecalD(var nVe,nVs: ar_w); pascal; assembler; forward;
	{ recopie un vecteur en le dcalant d'un bit vers la droite }
	{ entre nVe (128 bits); sortie: nVs (128 bits) }
procedure DecalG(var nVe,nVs: ar_w); pascal; assembler; forward;
	{ recopie un vecteur en le dcalant d'un bit vers la gauche }
	{ entre nVe (128 bits); sortie: nVs (128 bits) }
procedure vecteur8_7(var nV8,nV7: ar_w; var par:boolean);
procedure vecteur7_8(par:boolean; var nV7,nV8: ar_w);
procedure OuExclusif8(var na,nb: ar_w);
         { entre: na et nb }
         { sortie: na       }
procedure complement8(var na: ar_w);
function semblable8(var na,nb: ar_w): boolean;
procedure voiler(var nw: ar_w);
         { sortie: nw (128 bits pseudo-alatoires), procdure rapide }
function voilerVect: string;
         { sortie: 32 caractres hexadcimaux pseudo-alatoires }

IMPLEMENTATION

uses
  ClassicMath;

FUNCTION conforme8(nw: ar_w): boolean;
	{ entre: nw					        }
	{ sortie: conforme8 = true                              }
        {         sauf si nw = 00000000000000000000000000000000 }
        {                      7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF }
        {                      80000000000000000000000000000000 }
        {                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF }
label
  lab;
var
  lg: integer;
begin
  result:=false;
  nw[8]:=nw[8] and $7FFF;		{ nw a t pass par valeur }
  lg:=8;
  while (lg>1) and (nw[lg]=0) do dec(lg);
  if (lg=1) and (nw[1]=0) then goto lab;
  if (lg=8) and (nw[8]=$7FFF) then begin
    dec(lg);
    while (lg>0) and (nw[lg]=$FFFF) do dec(lg);
    if lg=0 then goto lab end;
  result:=true;
  lab:
  voiler(nw);
end;

FUNCTION parite(var na: ar_w): boolean; pascal; assembler;
         { sortie = true lorsque le nombre de bits 1 est pair dans na }
asm
	push edi
	xor ax,ax
	mov edi,na
	mov ecx,8
    @1:
	xor ax,[edi]
	inc edi; inc edi
	loop @1
	xor al,ah
	mov ax,0000h      { false }
	jnp @2
	mov ax,0001h      { true }
    @2:
        pop edi
end;

PROCEDURE DecalD(var nVe,nVs: ar_w); pascal; assembler;
	{ recopie un vecteur en le dcalant d'un bit vers la droite }
	{ entre nVe (128 bits); sortie: nVs (128 bits) }
asm
  	push esi; push edi; std
  	mov ecx,4; clc
  	mov esi,nVe; mov edi,nVs
  	add esi,12; add edi,12
    @1:
  	lodsd; rcr eax,1; stosd;
  	loop @1
  	cld; pop edi; pop esi
end;

PROCEDURE DecalG(var nVe,nVs: ar_w); pascal; assembler;
	{ recopie un vecteur en le dcalant d'un bit vers la gauche }
	{ entre nVe (128 bits); sortie: nVs (128 bits) }
asm
	push esi; push edi
        mov ecx,4; clc
	mov esi,nVe; mov edi,nVs
    @1:
	lodsd; rcl eax,1; stosd
	loop @1
	pop edi; pop esi
end;

PROCEDURE vecteur8_7(var nV8,nV7: ar_w; var par:boolean);
begin
  par:=parite(nV8);
  if par then DecalD(nV8,nV7)
  else begin
    move(nV8,nV7,16);
    nV7[8]:=nV7[8] and $7FFF end;
end;

PROCEDURE vecteur7_8(par:boolean; var nV7,nV8: ar_w);
var
  pV7: boolean;
begin
  pV7:=parite(nV7);
  if par then begin
    DecalG(nV7,nV8);
    if par<>pV7 then nV8[1]:=nV8[1] or $0001 end
  else begin
    move(nV7,nV8,16);
    if par<>pV7 then nV8[8]:=nV8[8] or $8000 end;
end;

PROCEDURE OuExclusif8(var na,nb: ar_w);
         { entre: na et nb }
         { sortie: na       }
var
  i: integer;
begin
  for i:=1 to 8 do na[i]:=na[i] xor nb[i];
end;

PROCEDURE complement8(var na: ar_w);
var
  i: integer;
begin
  for i:=1 to 8 do na[i]:=not na[i];
end;

FUNCTION semblable8(var na,nb: ar_w): boolean;
var
  lg: integer;
begin
  result:=false;
  lg:=8;
  while (lg>0) and (na[lg]=nb[lg]) do dec(lg);
  if lg>0 then exit;
  result:=true;
end;

PROCEDURE voiler(var nw: ar_w);
         { sortie: nw (128 bits pseudo-alatoires), procdure rapide }
var
  i:integer;
begin
  randomize;
  for i:=1 to 8 do nw[i]:=random($10000);
end;

FUNCTION voilerVect: string;
         { sortie: 32 caractres hexadcimaux pseudo-alatoires }
var
  i:integer;
begin
  randomize;
  result:='';
  for i:=1 to 8 do result:=result+WordHex(random($10000));
end;

END.

