unit ClassicDemo1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, printers;

type
  TFormDemo = class(TForm)
    LabelMessage: TLabel;
    LabelClef: TLabel;
    LabelXor: TLabel;
    EditMsg: TEdit;
    EditMsgH: TEdit;
    EditClef: TEdit;
    EditXor: TEdit;
    RadioBtnMsg: TRadioButton;
    RadioBtnMsgH: TRadioButton;
    LabelClef1: TLabel;
    LabelXor1: TLabel;
    BitBtnAfficher: TBitBtn;
    BitBtnImprimer: TBitBtn;
    PrintDialog: TPrintDialog;
    BitBtnQuitter: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure RadioBtnMsgClick(Sender: TObject);
    procedure EditMsgChange(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure BitBtnAfficherClick(Sender: TObject);
    procedure BitBtnImprimerClick(Sender: TObject);
  private
    { Dclarations prives }
    a,b,y,y1,y2,y3,y4: integer;
    procedure composer(const canevas: Tcanvas);
    procedure boutons;
  public
    { Dclarations publiques }
  end;

var
  FormDemo: TFormDemo;

implementation

{$R *.DFM}

uses
  ClassicDecla, ClassicCalcul, ClassicCalcul8, ClassicMath8, ClassicDlm8Demo,
  ClassicKi, ClassicDemo2;

procedure TFormDemo.FormActivate(Sender: TObject);
begin
  boutons;
end;

procedure TFormDemo.RadioBtnMsgClick(Sender: TObject);
begin
  if RadioBtnMsg.checked then begin
    EditMsg.show;
    EditMsgH.text:='';
    EditMsgH.hide end
  else begin
    EditMsg.hide;
    EditMsg.text:='';
    EditMsgH.show end;
end;

procedure TFormDemo.EditMsgChange(Sender: TObject);
begin
  boutons;
end;

procedure TFormDemo.EditChange(Sender: TObject);
var
  nk: ar_w;
  texte: string;
  editeur: TEdit;
  curseur: integer;
  i: integer;
begin
  editeur:=TEdit(sender);
// verification des chiffres hexadcimaux
  for i:=1 to length(editeur.text) do begin
    if not (editeur.text[i] in ['0'..'9','A'..'F']) then begin
      curseur:=editeur.SelStart;
      texte:=copy(editeur.text,1,i-1)+
      copy(editeur.text,i+1,length(editeur.text)-i);
      editeur.text:=texte;
      editeur.SelStart:=curseur-1;
      break end end;
// verification de la conformit de la clef
  if (sender=EditClef) and (length(EditClef.text)=32) then begin
    EntreeH8(EditClef.text,nk);
    if not conforme8(nk) then begin
      messagedlg('Cette clef ne peut tre accepte.',mtError,[mbOk],0);
      EditClef.text:='' end end;
  boutons;
end;

procedure TFormDemo.BitBtnAfficherClick(Sender: TObject);
begin
  a:=10; b:= 250; y1:=20; y2:=30; y3:=30; y4:=250;
// cration d'une instance de FormDemo2 qui n'est pas cre d'avance,
// voir Projet/Options/Fiches.
// Plusieurs instances peuvent tre affiches simultanment.
  FormDemo2:=TFormDemo2.Create(self);  // fiche dtruite en la quittant, voir
  FormDemo2.left:=left;                // TFormDemo2.BitBtnQuitterClick.
  FormDemo2.top:=top+160;
  with FormDemo2 do begin            // bugs ?
    height:=470;                     // doit tre redfini
    constraints.MaxWidth:=510;       // seule contrainte devant tre redfinie!
    ScrollBar.position:=ScrollBar.min; // doit tre redfini
    if RadioBtnMsg.checked then begin
      image.height:=702;
      ScrollBar.max:=702;
      constraints.MaxHeight:=770 end
    else begin
      image.height:=662;
      ScrollBar.max:=662;
      constraints.MaxHeight:=730 end end;
  y:=14;
  composer(FormDemo2.image.canvas);
end;

procedure TFormDemo.BitBtnImprimerClick(Sender: TObject);
begin
  if not PrintDialog.execute then exit;
  a:=850; b:= 2800; y1:=130; y2:=180; y3:=250; y4:=2500;
  with printer,canvas,font do begin
    BeginDoc;
    size:=10;
    name:='MS Sans Serif';
    y:=250;
    TextOut(2500-(TextWidth('EXECUTION DE L''ALGORITHME SED') div 2),y,
    'EXECUTION DE L''ALGORITHME SED');
    y:=y+250 end;
  composer(printer.canvas);
  printer.EndDoc;
end;

procedure TFormDemo.composer(const canevas: Tcanvas);
var
  msg: string;
  nMsg,nCle,nClei,nXor,nSed,nSedi: ar_w;
begin
  if RadioBtnMsg.checked then begin
    msg:=EditMsg.text;
    VMsg8:=CarHex(msg) end
  else VMsg8:=EditMsgH.text;
  EntreeH8(VMsg8,nMsg);
  VCle8:=EditClef.text; EntreeH8(VCle8,nCle);
  VXor:=EditXor.text; EntreeH8(VXor,nXor);
  Sed8X(nMsg,nCle,nXor,nSed,true);
  with canevas,font do begin
    TextOut(y4-(TextWidth('CHIFFREMENT') div 2),y,'CHIFFREMENT');
    y:=y+y2;
    if RadioBtnMsg.checked then begin
      TextOut(a,y,'Message en clair');
      name:='Courier New'; TextOut(b,y,msg);
      y:=y+y1 end;
    name:='MS Sans Serif'; TextOut(a,y,'Message en chiffres hexadcimaux');
    name:='Courier New'; TextOut(b,y,VMsg8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 127 bits');
    name:='Courier New'; TextOut(b,y,VMsg7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Clef en chiffres hexadcimaux');
    name:='Courier New'; TextOut(b,y,VCle8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 127 bits');
    name:='Courier New'; TextOut(b,y,VCle7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Vecteur XOR en chiffres hexadcimaux');
    name:='Courier New'; TextOut(b,y,VXor);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Rsultat de l''algorithme DLM63');
    name:='Courier New'; TextOut(b,y,VDlm7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 128 bits');
    name:='Courier New'; TextOut(b,y,VDlm8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Complment ventuel');
    name:='Courier New'; TextOut(b,y,VCpl8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 127 bits');
    name:='Courier New'; TextOut(b,y,VCpl7);
    y:=y+y1;
    name:='MS Sans Serif';
    TextOut(a,y,'Rsultat de la multiplication modulaire');
    name:='Courier New'; TextOut(b,y,VMul7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 128 bits');
    name:='Courier New'; TextOut(b,y,VMul8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Rsultat de l''XOR');
    name:='Courier New'; TextOut(b,y,VXor8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 127 bits');
    name:='Courier New'; TextOut(b,y,VXor7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Rsultat de l''algorithme DLM30');
    name:='Courier New'; TextOut(b,y,VSed7);
    y:=y+y1;
    name:='MS Sans Serif';
    TextOut(a,y,'Message chiffr (conversion en 128 bits)');
    name:='Courier New'; TextOut(b,y,VSed8) end;
  inverse8(nCle,nclei);
  Sed8X(nSed,nClei,nXor,nSedi,false);
  VMsg8:=BinHex8(nSed);
  Vsed8:=BinHex8(nSedi);
  with canevas,font do begin
    y:=y+y3;
    name:='MS Sans Serif';
    TextOut(y4-(TextWidth('DECHIFFREMENT') div 2),y,'DECHIFFREMENT');
    y:=y+y2;
    TextOut(a,y,'Message chiffr');
    name:='Courier New'; TextOut(b,y,VMsg8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 127 bits');
    name:='Courier New'; TextOut(b,y,VMsg7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Clef inverse en 127 bits');
    name:='Courier New'; TextOut(b,y,VCle7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Rsultat de l''algorithme DLM30');
    name:='Courier New'; TextOut(b,y,VDlm7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 128 bits');
    name:='Courier New'; TextOut(b,y,VDLM8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Rsultat de l''XOR');
    name:='Courier New'; TextOut(b,y,VXor8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 127 bits');
    name:='Courier New'; TextOut(b,y,VXor7);
    y:=y+y1;
    name:='MS Sans Serif';
    TextOut(a,y,'Rsultat de la multiplication modulaire');
    name:='Courier New'; TextOut(b,y,VMul7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 128 bits');
    name:='Courier New'; TextOut(b,y,VMul8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Complment ventuel');
    name:='Courier New'; TextOut(b,y,VCpl8);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 127 bits');
    name:='Courier New'; TextOut(b,y,VCpl7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Rsultat de l''algorithme DLM63');
    name:='Courier New'; TextOut(b,y,VSed7);
    y:=y+y1;
    name:='MS Sans Serif'; TextOut(a,y,'Conversion en 128 bits');
    name:='Courier New'; TextOut(b,y,VSed8);
    if RadioBtnMsg.checked then begin
      y:=y+y1;
      name:='MS Sans Serif';
      TextOut(a,y,'Message dchiffr (conversion en 16 caractres)');
      name:='Courier New'; TextOut(b,y,HexCar(VSed8)) end end;
end;

procedure TFormDemo.boutons;
begin
  if ((length(EditMsg.text)=16) or (length(EditMsgH.text)=32)) and
  (length(EditClef.text)=32) and (length(EditXor.text)=32)
  then begin
    BitBtnAfficher.enabled:=true;
    BitBtnAfficher.SetFocus;
    BitBtnImprimer.enabled:=true end
  else begin
    BitBtnAfficher.enabled:=false;
    BitBtnImprimer.enabled:=false end;
end;

end.
