UNIT ClassicDlm7;

{	MANIPULATION DE NOMBRES DE DIMENSION FIXE DE 127 BITS		    }

{  Les vecteurs de 127 bits sont segments en 8 paquets de 16 bits          }
{  et manipuls au moyen de variables tableaux (array of word).		    }
{  Le paquet de 16 bits le moins significatif est plac  l'indice 1.	    }
{  Un bit n'est pas utilis; il sagit :					    }
{  du bit le plus significatif pour les entres/sorties et les clefs;	    }
{  du bit le moins significatif pour les vecteurs des registres  dcalage, }
{  les relations linaires et les rsultats des calculs matriciels.	    }
{  Lorsque des tableaux sont transmis aux procdures et aux fonctions	    }
{  ils sont passs par adresse; il est veill  ce qu'ils ne soient pas	    }
{  modifis par la procdure ou la fonction sauf lorsqu'ils sont destins   }
{   recevoir un rsultat.						    }
{  Le type des tableaux (ar_w) est dclar dans une autre unit.            }

INTERFACE

uses
  ClassicDecla;

procedure dlm(var nVe,nCle,nVs: ar_w; num: boolean);
	{ application de l'algorithme DLM		        }
	{ entres: nVe (vecteur), nCle (clef)                   }
	{ 	   num:=true pour l'algorithme 63 (lment 64), }
        {               false pour l'algorithme 30 (lment 97) }
	{ sortie: nVs				                }

IMPLEMENTATION

uses
  ClassicCalcul8;

type
  tRelation=procedure; pascal;
  tProduit=procedure(var wR: ar_w); pascal;

var
  nVec,nV,nRel,nRel0: ar_w;
  relation: tRelation;
  produit: tProduit;

procedure rel63; pascal; assembler; forward;
        { relation linaire unissant un vecteur aux 127 premiers vecteurs }
        { entre: nVec; sortie: nRel                                      }
procedure rel30; pascal; assembler; forward;
	{ relation linaire unissant un vecteur aux 127 premiers vecteurs }
	{ entre: nVec; sortie: nRel                                      }
procedure prod63(var nR: ar_w); pascal; assembler; forward;
	{ saut effectu par application d'une relation		 }
	{  127 vecteurs conscutifs				 }
	{ entres: nR (la relation)                              }
	{	   nVec (le vecteur dans le registre  dcalage) }
	{ variable de travail: nV				 }
	{ sortie: nVec (aprs copie de nV dans cette variable	 }
procedure prod30(var nR: ar_w); pascal; assembler; forward;
	{ saut effectu par application d'une relation		 }
	{  127 vecteurs conscutifs				 }
	{ entres: nR (la relation)                              }
	{	   nVec (le vecteur dans le registre  dcalage) }
	{ variable de travail: nV				 }
	{ sortie: nVec (aprs copie de nV dans cette variable	 }

{------------------------------------------------------------------------------}

PROCEDURE dlm(var nVe,nCle,nVs: ar_w; num: boolean);
	{ application de l'algorithme DLM		        }
	{ entres: nVe (vecteur), nCle (clef)                   }
	{ 	   num:=true pour l'algorithme 63 (lment 64), }
        {               false pour l'algorithme 30 (lment 97) }
	{ sortie: nVs				                }
var
  LgCle: integer;
  i,j: integer;
  acc: longint;
  ac: r_w absolute acc;
begin
  if num then begin
    relation:=rel63; produit:=prod63 end
  else begin
    relation:=rel30; produit:=prod30 end;
  DecalG(nVe,nVec);
  relation;
  move(nRel,nRel0,16);
  lgCle:=8;
  while (nCle[lgCle]=0) and (lgCle>1) do dec(lgCle);
  acc:=nCle[lgCle];
  i:=0;
  repeat
    inc(i);
    acc:= acc shl 1;
  until ac.h=1;
  ac.h:=0;
  for j:=i+1 to 16 do begin
    acc:= acc shl 1;
    relation;
    produit(nRel);
    if ac.h=1 then begin
      produit(nRel0);
      ac.h:=0 end end;
  for i:=lgCle-1 downto 1 do begin
    ac.b:=nCle[i];
    for j:=1 to 16 do begin
      acc:= acc shl 1;
      relation;
      produit(nRel);
      if ac.h=1 then begin
        produit(nRel0);
        ac.h:=0 end end end;
  decalD(nVec,nVs);
  voiler(nV);
  voiler(nVec);
end;

procedure rel63; pascal; assembler;
        { relation linaire unissant un vecteur aux 127 premiers vecteurs }
        { entre: nVec; sortie: nRel                                      }
asm
	push esi; push edi
	mov ax,ds; mov es,ax
	clc; mov ecx,4
	lea esi,nVec; lea edi,nRel
    @1:				{ oblique adjacente de la matrice inverse }
	lodsd;
	rcl eax,1
	stosd;
	loop @1
	jnc @2
	or nRel.dWord,0002h     { lment 1,127 de la matrice inverse }
    @2:
	mov ecx,4
	sub esi,16; sub edi,16;
    @3:                         { diagonale principale de la matrice inverse }
	lodsd;
	xor eax,[edi]
	stosd;
	loop @3
	mov ecx,2
	lea esi,nRel+8; lea edi,nRel
    @4:				{ 2 petites obliques de la matrice inverse }
	lodsd;
	xor eax,[edi]
	stosd;
	loop @4
	mov eax,nVec.dWord+8
	shl eax,1               { correction pour l'lment 1,64 }
	and eax,0002h
	xor eax,nRel.dWord
	and eax,0FFFFFFFEh
	mov nRel.dWord,eax
	pop edi; pop esi
end;

procedure rel30; pascal; assembler;
	{ relation linaire unissant un vecteur aux 127 premiers vecteurs }
	{ entre: nVec; sortie: nRel                                      }
asm
	push esi; push edi
	mov ax,ds; mov es,ax
	clc; mov ecx,4
	lea esi,nVec; lea edi,nRel
    @1:                         { oblique adjacente de la matrice inverse }
	lodsd;
	rcl eax,1
	stosd;
	loop @1
	jnc @2
	or nRel.dWord,0002h     { lment 1,127 de la matrice inverse }
    @2:
	mov ecx,4
	sub esi,16; sub edi,16;
    @3:				{ diagonale principale de la matrice inverse }
	lodsd;
	xor eax,[edi]
	stosd;
	loop @3
	mov eax,nRel.dWord+12   { 2 petites obliques de la matrice inverse }
	rcr eax,1
	xor nRel.dWord,eax
	mov eax,nVec.dWord+12
	and eax,0002h		{ correction pour l'lment 1,97 }
	xor eax,nRel.dWord
	and eax,0FFFFFFFEh
	mov nRel.dWord,eax
	pop edi; pop esi
end;

procedure prod63(var nR: ar_w); pascal; assembler;
	{ saut effectu par application d'une relation		 }
	{  127 vecteurs conscutifs				 }
	{ entres: nR (la relation)                              }
	{	   nVec (le vecteur dans le registre  dcalage) }
	{ variable de travail: nV				 }
	{ sortie: nVec (aprs copie de nV dans cette variable	 }
asm
	push esi; push edi
	mov ecx,4		{ effacer nV }
	lea edi,nV
	xor eax,eax
	rep stosd
	mov ecx,4
	mov esi,nR              { appeler les bits de nR un  un }
	lodsd; mov edx,eax
	push ecx
	shr edx,1; mov ecx,31   { commencer au bit 1 en passant le bit 0 }
    @1:
	shr edx,1
	jnc @2                  { passer si le bit considr est nul }
	mov eax,nVec.dWord      { nV = nV xor nVec }
	xor nV.dWord,eax
	mov eax,nVec.dWord+4
	xor nV.dWord+4,eax
	mov eax,nVec.dWord+8
	xor nV.dWord+8,eax
	mov eax,nVec.dWord+12
	xor nV.dWord+12,eax
    @2:
	push edx
	mov edx,nVec.dWord      { avancer d'un pas le registre  dcalage nVec}
	rcl edx,1
	mov eax,nVec.dWord+4
	rcl eax,1
	mov nVec.dWord+4,eax
	mov edi,nVec.dWord+8
	rcl edi,1
	mov nVec.dWord+8,edi
	mov eax,nVec.dWord+12
	rcl eax,1
	mov nVec.dWord+12,eax
	jnc @3
	or edx,0002h            { report du bit 127 }
    @3:
	and edi,0002h           { bit 64 }
	xor edx,edi
	mov nVec.dWord,edx
	pop edx
	loop @4
	pop ecx
	loop @5
	jmp @6
    @4:
	jmp @1
    @5:
	lodsd; mov edx,eax
	push ecx; mov ecx,32
	jmp @1
    @6:
	lea esi,nV
        lea edi,nVec            { copier nV dans nVec }
	mov ecx,4
	rep movsd
	pop edi; pop esi
end;

procedure prod30(var nR: ar_w); pascal; assembler;
	{ saut effectu par application d'une relation		 }
	{  127 vecteurs conscutifs				 }
	{ entres: nR (la relation)                              }
	{	   nVec (le vecteur dans le registre  dcalage) }
	{ variable de travail: nV				 }
	{ sortie: nVec (aprs copie de nV dans cette variable	 }
asm
	push esi; push edi
	mov ecx,4		{ effacer nV }
	lea edi,nV
	xor eax,eax
	rep stosd
	mov ecx,4
	mov esi,nR              { appeler les bits de nR un  un }
	lodsd; mov edx,eax
	push ecx
	shr edx,1; mov ecx,31   { commencer au bit 1 en passant le bit 0 }
    @1:
	shr edx,1
	jnc @2                  { passer si le bit considr est nul }
	mov eax,nVec.dWord      { nV = nV xor nVec }
	xor nV.dWord,eax
	mov eax,nVec.dWord+4
	xor nV.dWord+4,eax
	mov eax,nVec.dWord+8
	xor nV.dWord+8,eax
	mov eax,nVec.dWord+12
	xor nV.dWord+12,eax
    @2:
	push edx
	mov edx,nVec.dWord	{ avancer d'un pas le registre  dcalage nVec}
	rcl edx,1
	mov eax,nVec.dWord+4
	rcl eax,1
	mov nVec.dWord+4,eax
	mov eax,nVec.dWord+8
	rcl eax,1
	mov nVec.dWord+8,eax
	mov edi,nVec.dWord+12
	rcl edi,1
	mov nVec.dWord+12,edi
	jnc @3
	or edx,0002h            { report du bit 127 }
    @3:
	shr edi,1
	and edi,0002h           { bit 97 }
	xor edx,edi
	mov nVec.dWord,edx
	pop edx
	loop @4
	pop ecx
	loop @5
	jmp @6
    @4:
	jmp @1
    @5:
	lodsd; mov edx,eax
	push ecx; mov ecx,32
	jmp @1
    @6:
	lea esi,nV
        lea edi,nVec		{ copier nV dans nVec }
	mov ecx,4
	rep movsd
	pop edi; pop esi
end;

END.
