UNIT ClassicMath;

{  MANIPULATION DE GRANDS NOMBRES POSITIFS DE DIMENSION VARIABLE	}

{  Les nombres de dimension variable sont segments en paquets de	}
{  16 bits et manipuls au moyen de variables tableaux (array of word). }
{  Le paquet de 16 bits le moins significatifs est plac  l'indice 1.	}
{  Chaque variable tableau est accompagne d'une variable de dimension  }
{  indiquant le nombre d'indices effectivement utiliss.                }
{  L'indice le plus significatif effectivement utilis dsigne norma-   }
{  lement un paquet de bits diffrent de zro; toutefois l'indice 1     }
{  doit toujours tre effectivement utilis mme si le grand nombre     }
{  est nul.								}
{  Les indicateurs des variables tableaux commencent tous par la        }
{  lettre n et ceux des variables de dimension correspondantes par les	}
{  lettres lg.								}
{  Les tableaux sont toujours passs par adresse aux procdures et aux  }
{  fonctions; il est veill  ce qu'ils ne soient pas modifis par      }
{  la procdure ou la fonction sauf lorsqu'ils sont destins  recevoir }
{  un rsultat.							        }
{  Le type des tableaux (ar_w) est dclar dans une autre unit.        }

INTERFACE

uses
  ClassicDecla;

function EntreeH(nbr: string; var nw: ar_w; var lg: integer): boolean;
	{ entre: nbr (nombre en caractres hexadcimaux) }
	{ sortie: si nbr est un nombre hexadcimal        }
	{            nw, lgw = conversion binaire de nbr  }
function EntreeD(nbr: string; var nw: ar_w; var lg: integer): boolean;
	{ entre: nbr (nombre en caractres dcimaux)    }
	{ sortie: si nbr est un nombre dcimal           }
	{            nw, lgw = conversion binaire de nbr }
function BinHex(var nw: ar_w; lg: integer): string;
	{ sortie: chane de 4*lg caractres hexadcimaux }
function BinDec(var nw: ar_w; lg: integer): string;          { inutilise }
	{ sortie: chane de 39 caractres dcimaux }
procedure hasard(var nw: ar_w; lg: integer);
	{ sortie: nW (16*lg bits pseudo-alatoires) }
function WordHex(adr: word): string;
        { renvoie 4 caractres hexadcimaux }

IMPLEMENTATION

procedure DivParWord(var nw: ar_w; var lg: integer; divi: word;
           var reste: word); pascal; forward;
	{ entres: nw, lg (le dividende); divi (le diviseur de 16 bits) }
	{ sorties: nw, lg (le quotient); reste (le reste de 16 bits)	}

{------------------------------------------------------------------------------}

FUNCTION EntreeH(nbr: string; var nw: ar_w; var lg: integer): boolean;
	{ entre: nbr (nombre en caractres hexadcimaux) }
	{ sortie: si nbr est un nombre hexadcimal        }
	{            nw, lgw = conversion binaire de nbr  }
var
  nb: ar_b absolute nw;
  i: integer;
begin
  result:=false;
  while (length(nbr)>0) and (nbr[1]=' ')
  do nbr:=copy(nbr,2,length(nbr)-1);
  if nbr='' then exit;
  while (length(nbr)>4) and (nbr[1]='0')
  do nbr:=copy(nbr,2,length(nbr)-1);
  for i:=1 to length(nbr) do begin
    nbr[i]:=upcase(nbr[i]);
    if (ord(nbr[i])>$40) and (ord(nbr[i])<$47)
    then nbr[i]:=chr(ord(nbr[i])-7);
    if (ord(nbr[i])<$30) or (ord(nbr[i])>$3F) then exit end;
  if odd(length(nbr)) then nbr:='0'+nbr;
  lg:=length(nbr) div 2;
  for i:=lg downto 1 do
  nb[lg+1-i]:=ord(nbr[2*i])-$30+(ord(nbr[2*i-1])-$30)*16;
  if odd(lg) then begin
    inc(lg); nb[lg]:=0 end;
  lg:=lg div 2;
  result:=true;
end;

FUNCTION EntreeD(nbr: string; var nw: ar_w; var lg: integer): boolean;
	{ entre: nbr (nombre en caractres dcimaux)    }
	{ sortie: si nbr est un nombre dcimal           }
	{            nw, lgw = conversion binaire de nbr }
const
  base=4;
  mul:longint=10000;
var
  acc: longint;
  ac: r_w absolute acc;
  i,j: integer;
begin
  result:=false;
  while (length(nbr)>0) and (nbr[1]=' ')
  do nbr:=copy(nbr,2,length(nbr)-1);
  if nbr='' then exit;
  while (length(nbr)>4) and (nbr[1]='0')
  do nbr:=copy(nbr,2,length(nbr)-1);
  for i:=1 to length(nbr) do
  if (ord(nbr[i])<$30) or (ord(nbr[i])>$39) then exit;
  for i:=1 to 8 do nw[i]:=0;
  lg:=0;
  while (length(nbr) mod base)>0 do nbr:='0'+nbr;
  for i:=0 to (length(nbr) div base)-1 do begin
    acc:=0;
    for j:=1 to base do
    ac.h:=ac.h*10+ord(nbr[base*i+j])-$30;
    for j:=1 to lg do begin
      acc:=ac.h+mul*nw[j];
      nw[j]:=ac.b end;
    if ac.h>0 then begin
      inc(lg); nw[lg]:=ac.h end;
    if lg=0 then lg:=1 end;
  result:=true;
end;

FUNCTION BinHex(var nw: ar_w; lg: integer): string;
	{ sortie: chane de 4*lg caractres hexadcimaux }
var
  hexa: string;
  i: integer;
begin
  hexa:='';
  for i:=1 to lg do hexa:=WordHex(nw[i])+hexa;
  result:=hexa;
end;

FUNCTION BinDec(var nw: ar_w; lg: integer): string;
	{ sortie: chane de 39 caractres dcimaux }
const
  base=4;
  d=10000;
var
  nq: ar_w;
  lgq: integer;
  deci: string;
  reste: word;
  i: integer;
begin
  deci:='';
  for i:=1 to lg do nq[i]:=nw[i]; lgq:=lg;
  while (lgq>1) or (nq[1]>0) do begin
    DivParWord(nq,lgq,d,reste);
    for i:=1 to base do begin
      deci:=chr((reste mod 10)+48)+deci;
      reste:=reste div 10 end end;
  if length(deci)=40 then deci:=copy(deci,2,39);
  while length(deci)<39 do deci:='0'+deci;
  result:=deci;
end;

PROCEDURE hasard(var nw: ar_w; lg: integer);
	{ sortie: nw (16*lg bits pseudo-alatoires) }
var
  i,j: integer;
  rd,rd0,rd1: word;
begin
  randomize;
  for i:=1 to lg do begin
    for j:=1 to 23 do rd:=random(27);
    for j:=1 to rd-1 do random(256);
    rd0:=random(256);
    for j:=1 to 23 do rd:=random(27);
    for j:=1 to rd-1 do random(256);
    rd1:=random(256);
    nw[i]:=rd0+(rd1 shl 8) end;
end;

FUNCTION WordHex(adr: word): string;
         { renvoie 4 caractres hexadcimaux }
var
  n: array[1..4] of byte;
  i: byte;
begin
  result:='';
  n[1]:=hi(adr) shr 4;
  n[2]:=hi(adr) and $0f;
  n[3]:=lo(adr) shr 4;
  n[4]:=lo(adr) and $0f;
  for i:=1 to 4 do begin
    if n[i]>9 then result:=result+chr(n[i]+$37)
    else result:=result+chr(n[i]+$30) end;
end;

procedure DivParWord(var nw: ar_w; var lg: integer; divi: word;
           var reste: word); pascal;
	{ entres: nw, lg (le dividende); divi (le diviseur de 16 bits) }
	{ sorties: nw, lg (le quotient); reste (le reste de 16 bits)	}
begin
  asm
  	push edi; std
	xor dx,dx; mov edi,lg; mov ecx,[edi]
	mov edi,nw; mov eax,ecx; dec eax
	add eax,eax; add edi,eax
    @1:
	mov ax,[edi]; div divi; stosw
	loop @1
	mov edi,reste; mov [edi],dx
	cld; pop edi
  end;
  while (nw[lg]=0) and (lg>1) do dec(lg);
end;

END.
