unit ClassicMath7;

interface

uses
  ClassicDecla;

procedure mam7(var na,nb,nc: ar_2w);

implementation

uses
  ClassicCalcul8;

procedure Addi2W(var na: ar_2w; W: word; deca: integer); pascal; assembler;
                 forward;
	{ na = na + 2*W*2exp(16*deca) }
procedure addi1(var na: ar_2w); pascal; assembler; forward;
	{ na = na + 1 }
procedure mod127(var na: ar_2w; var lga: integer); forward;
	{ entre: na, lga				 }
	{ sortie: na, lga   na = na modulo (2exp127 - 1) }
procedure multi(var na: ar_2w; lga: integer;
	        var nb: ar_2w; lgb: integer; var np: ar_2w; var lgp: integer);
	        pascal; assembler; forward;
	{ entre: na, lga;  nb, lgb		}
	{ sortie: np, lgp   produit de na et nb }

{------------------------------------------------------------------------------}

procedure mam7(var na,nb,nc: ar_2w);
var
  lga,lgb,lgc: integer;
begin
  lga:=8; lgb:=8;
  multi(na,lga,nb,lgb,nc,lgc); mod127(nc,lgc);
end;

procedure Addi2W(var na: ar_2w; W: word; deca: integer); pascal; assembler;
	{ na = na + 2*W*2exp(16*deca) }
asm
	push edi
	xor dx,dx
	mov cx,W; shl cx,1
	rcl dx,1
	mov edi,na; add edi,deca; add edi,deca
	mov ax,[edi]; add ax,cx; stosw
	mov ax,[edi]; adc ax,dx; stosw
    @1:
	jnc @2
	mov ax,[edi]; adc ax,0; stosw
	jmp @1
    @2:
        pop edi
end;

procedure addi1(var na: ar_2w); pascal; assembler;
	{ na = na + 1 }
asm
	push edi
	mov edi,na
	mov ax,[edi]; add ax,1; stosw
    @1:
	jnc @2
	mov ax,[edi]; adc ax,0; stosw
	jmp @1
    @2:
        pop edi
end;

procedure mod127(var na: ar_2w; var lga: integer);
	{ entre: na, lga				 }
	{ sortie: na, lga   na = na modulo (2exp127 - 1) }
var
  quot: word;
  deca: integer;
  i: integer;
begin
  if (lga<8) or ((lga=8) and (na[lga]<$7fff)) then exit;
  while lga>8 do begin
    deca:=lga-9;
    quot:=na[lga]; na[lga]:=0; 	{ na[lga] est annul et	son ancienne }
    Addi2W(na,quot,deca);    	{ valeur est ajoute deux fois }
    if na[lga]>0 then begin    	{  na avec le dcalage appropri }
      na[lga]:=0;
      Addi2W(na,1,deca) end;
    while (lga>1) and (na[lga]=0) do dec(lga) end;
  if lga=8 then begin
    while (lga=8) and (na[lga]>$7fff) do begin
      na[8]:=na[8] and $7fff; 	{ le bit le plus lev de na est annul }
      addi1(na);		{ et 1 est ajout  na }
      while (lga>1) and (na[lga]=0) do dec(lga) end end;
  if (lga=8) and (na[lga]=$7fff) then begin
    i:=7;
    while (i>0) and (na[i]=$ffff) do dec(i);
    if i=0 then begin
      na[1]:=0; lga:=1 end end;
end;

procedure multi(var na: ar_2w; lga: integer;
	        var nb: ar_2w; lgb: integer; var np: ar_2w; var lgp: integer);
	        pascal; assembler;
	{ entre: na, lga;  nb, lgb		}
	{ sortie: np, lgp   produit de na et nb }
var
  rp,multi: word;
  jj: integer;
asm
	push esi; push edi
	mov rp,0; mov ecx,lga   { premiers produits }
	mov esi,nb; mov ax,[esi]
        mov multi,ax            { na[i]*nb[1]  i>1  }
	mov esi,na; mov edi,np
    @1:
	lodsw; mul multi
	add ax,rp; adc dx,0
	stosw; mov rp,dx; loop @1
	mov [edi],dx
	mov ecx,lgb; dec ecx; jcxz @4
	mov jj,0;
    @2:
	push ecx;               { les autres produits }
	mov rp,0; mov ecx,lga
	mov esi,nb; add jj,2; add esi,jj; mov ax,[esi]; mov multi,ax
	mov esi,na; mov edi,np; add edi,jj
    @3:
	lodsw; mul multi
	add ax,[edi]; adc dx,0
	add ax,rp; adc dx,0
	stosw; mov rp,dx; loop @3
	mov [edi],dx; pop ecx; loop @2
    @4:
	mov eax,lgb; add eax,lga
	cmp dx,0; jne @5
	dec eax
    @5:
	mov esi,lgp; mov [esi],eax
	pop edi; pop esi
end;

end.
 